--camera by Michael Ebens 
camera = {}
camera._x = 0
camera._y = 0
camera.scaleX = 1
camera.scaleY = 1
camera.rotation = 0

function camera:set()
  love.graphics.push()
  love.graphics.rotate(-self.rotation)
  love.graphics.scale(1 / self.scaleX, 1 / self.scaleY)
  love.graphics.translate(-self._x, -self._y)
end

function camera:unset()
  love.graphics.pop()
end

function camera:move(dx, dy)
  self._x = self._x + (dx or 0)
  self._y = self._y + (dy or 0)
end

function camera:rotate(dr)
  self.rotation = self.rotation + dr
end

function camera:scale(sx, sy)
  sx = sx or 1
  self.scaleX = self.scaleX * sx
  self.scaleY = self.scaleY * (sy or sx)
end

function camera:setX(value)
  if self._bounds then
    self._x = math.clamp(value, self._bounds.x1, self._bounds.x2)
  else
    self._x = value
  end
end

function camera:setY(value)
  if self._bounds then
    self._y = math.clamp(value, self._bounds.y1, self._bounds.y2)
  else
    self._y = value
  end
end

function camera:setPosition(x, y)
  if x then self:setX(x) end
  if y then self:setY(y) end
end

function camera:setScale(sx, sy)
  self.scaleX = sx or self.scaleX
  self.scaleY = sy or self.scaleY
end

function camera:getBounds()
  return unpack(self._bounds)
end

function camera:setBounds(x1, y1, x2, y2)
  self._bounds = { x1 = x1, y1 = y1, x2 = x2, y2 = y2 }
end

function math.clamp(x, min, max)
  return x < min and min or (x > max and max or x)
end

--/camera

--tabletostring by lua-users wiki (http://lua-users.org/wiki/TableUtils)
function table.val_to_str ( v )
  if "string" == type( v ) then
    v = string.gsub( v, "\n", "\\n" )
    if string.match( string.gsub(v,"[^'\"]",""), '^"+$' ) then
      return "'" .. v .. "'"
    end
    return '"' .. string.gsub(v,'"', '\\"' ) .. '"'
  else
    return "table" == type( v ) and table.tostring( v ) or
      tostring( v )
  end
end

function table.key_to_str ( k )
  if "string" == type( k ) and string.match( k, "^[_%a][_%a%d]*$" ) then
    return k
  else
    return "[" .. table.val_to_str( k ) .. "]"
  end
end

function table.tostring( tbl )
  local result, done = {}, {}
  for k, v in ipairs( tbl ) do
    table.insert( result, table.val_to_str( v ) )
    done[ k ] = true
  end
  for k, v in pairs( tbl ) do
    if not done[ k ] then
      table.insert( result,
        table.key_to_str( k ) .. "=" .. table.val_to_str( v ) )
    end
  end
  return "{" .. table.concat( result, "," ) .. "}"
end
--/tabletostring

--main code by Wojak 
-- game states: -1 - .conf file restoring, 0 - .conf file processing, 1 - menu, 2 - game runing, 3 - pause, 4 - victory screen, 5 - fail screen
--		6 - display score, 7 - set score  

-- this should be love.load:

local imageplayer = love.graphics.newImage("tank1.png")
local imagebot = love.graphics.newImage("tank2.png")
local imagewall = love.graphics.newImage("wall.png")
local imagewat = love.graphics.newImage("wat.png")
local imagebri1 = love.graphics.newImage("bri1.png")
local imagebri2 = love.graphics.newImage("bri2.png")
local imagebri3 = love.graphics.newImage("bri3.png")
local imageice = love.graphics.newImage("ice.png")
local imagebus = love.graphics.newImage("bus.png")
local imagemud = love.graphics.newImage("mud.png")
local imagelaw = love.graphics.newImage("law.png")
local imagefir = love.graphics.newImage("fir.png")
local botsoushoot
local bulletsouhit
local soushoot
local souhit
local souboom 
local souride 
local scalex = 32/imageplayer:getWidth()
local scaley = 32/imageplayer:getHeight()
local scalexbus = 32/imagebus:getWidth()
local scaleybus = 32/imagebus:getHeight()
local isup = false
local isdown = false
local isleft = false
local isright = false
local interval = 0.1
local botinterval = 1
local udt = 0
local ddt = 0
local ldt = 0 
local rdt = 0
local botdt = 0
local screentimer = 5
local screendt = 0
local player
local map
local dynamicmap
local bottab = {}
local bullettab = {}
local botn = 15
local botleft = 5
local botincreeseamount = 5
local botincreese = 0
local width = love.graphics.getWidth()
local height = love.graphics.getHeight()
local gamestate = 0
local menustate = 2
local cursorstate =  height/2 -8 * 32
local shiftstate = false
local playsound = false
local playsounddisplay = "OFF"
local spawnmap = {}
local testtest = ""
local nmenu = false
local winstate = ""
local mapid = 1
local mapdraw = "1"
local directory = love.filesystem.getWorkingDirectory( )
local curmenu ={}
local menutab ={}
local pausemenutab = {}
local dificulitytab = {}
local backinmenutab = {}
local restoretab = {}
local suboptions = {}
local movetab = {}
startgametab = {}
local navtab = {}
local scoretab = {}
local specialkeytab = {}
local fileexsist, ok, chunk, result
local confprocesstab = {}
local spottab = {}

local savedir = love.filesystem.getSaveDirectory( )
--table.insert(confprocesstab,#confprocesstab + 1,savedir.."tank.conf")
--table.insert(confprocesstab,#confprocesstab + 1,tostring(type(souride)))

fileexsist = io.open(savedir.."/score.txt", "r")
if not fileexsist then
	local text = love.filesystem.read("scoreform.txt") 
	love.filesystem.write("score.txt",text)
end
local func = love.filesystem.load("score.txt")
scoretab = func()

local mp1 = {
up = "up",
down = "down",
left = "left",
right = "right",
shoot = "return",
pause = "escape"}
local maps ={"1.map","2.map","3.map","4.map","5.map","6.map","7.map","8.map"}
--map ids properties (edit-30-03-12)
local hasidcolision = {[1]=true,[2] = true, [3]=true,[4]=true,[5]=true} 
local hasidcolisionforbullets = {[2] = true, [3]=true,[4]=true,[5]=true} 
local hasidslowdowneffect = {[7]=1.2,[8]=1.2,[9]=1} 
local hasidsliperyeffect = {[6]=2,[8]=1,[9]=-1,[10]=-1} 
local hasiddamegeeffect = {[9]=2,[10]=1} 
local isdynamicidplayer = {[3] = true}
local isdynamicidbot = {[1] = true}
---
local p2_up = "w"
local p2_down = "s"
local p2_left = "a"
local p2_right = "d"
local p2_shoot = "r"
-- list of all (i hope) keys  "
local keytab = {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k",
 "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z","F1", "F2", "F3", "F4", "F5",
 "F6", "F7", "F8", "F9", "F10", "F11", "F12", "backspace", "tab", "lalt", "ralt", "return", " ", "pgup", "pgdn", "end", "home", "escape",
 "insert", "delete", "lshift", "rshift", "lctrl", "rctrl", "[", "]", "pause", "capslock", "scroll", ";", ",", "-", ".", "/",
 "#", "\\", "=","up", "down", "left", "right", "kp0","kp1","kp2","kp3","kp4","kp5","kp6","kp7","kp8","kp9","kp.","kp/","kp*",
"kp-","kp+","kpenter","kp="}
local textkeystab = {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k",
 "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", " "}
local iskeytab = {}
for i,key in pairs (textkeystab) do
	iskeytab[key] = true
end
-- more cleer names
local friendlyname = {["return"] = " (enter)",[" "] = " (space)", ["kp0"] = " (num 0)",["kp1"] = " (num 1)",["kp2"] = " (num 2)",["kp3"] = " (num 3)",["kp4"] = " (num 4)",
["kp5"] = " (num 5)",["kp6"] = " (num 6)",["kp7"] = " (num 7)",["kp8"] = " (num 8)",["kp9"] = " (num 9)",["kp."] = " (num ,)",["kp/"] = " (num /)",["kp*"] = " (num *)",
["kp-"] = " (num -)",["kp+"] = " (num +)",["kpenter"] = " (num enter)",["kp="] = " (num =)",["up"] = " (arrow up)",["down"] = " (arrow down)",
["left"] = " (arrow left)",["right"] = " (arrow right)"}
local iskey = {}
for i,key in pairs (keytab) do
	iskey[key] = true
end
function restoredefaultconf()
	local filestocreate = {"tankform.conf","customtest1.map","customtest2.map","readme(TanksReloaded).txt"}
	for i,f in pairs(filestocreate) do
		local defaultfile = love.filesystem.read(f) 
		local newfile
		if f == "tankform.conf" then 
			newfile = io.open("tank.conf", "w")
		else
			newfile = io.open(f, "w")
		end
		newfile:write(defaultfile)
		newfile:close()
	end
end

function assignkey (key,war) -- loading keys from tank.conf file
	if iskey[result.menu_player1[key]] then 
		mp1[war] = result.menu_player1[key]
	else
		winstate = "Invalid key indicator: \""..result.menu_player1[key].."\""
		table.insert(confprocesstab,#confprocesstab + 1,"Invalid key indicator: \""..result.menu_player1[key].."\"")
	end
end

function soundon()
	playsound = true
	playsounddisplay = "ON"
	soushoot = love.audio.newSource( "shoot.mp3", "static")
	botsoushoot = love.audio.newSource( "shoot.mp3", "static")
	bulletsouhit = love.audio.newSource( "hit.mp3", "static")
	souhit = love.audio.newSource( "hit.mp3", "static")
	souboom = love.audio.newSource( "boom.mp3", "static")
	souride = love.audio.newSource( "ride.mp3", "static")
	botsoushoot:setPitch(0.5)
	botsoushoot:setVolume(0.2)
	bulletsouhit:setPitch(0.38)
	bulletsouhit:setVolume(0.2)
	souride:setVolume(0.3)
	soushoot:setVolume(0.3)
end

function soundoff()
	playsound = false
	playsounddisplay = "OFF"
	soushoot = nil
	botsoushoot = nil
	bulletsouhit = nil
	souhit = nil
	souboom = nil
	souride = nil
end

function loadconfigfile()
	gamestate = 0
	menustate = 2
	confprocesstab = {}
	
-- loading tank.conf file
	fileexsist = false
	fileexsist =io.open(directory.."/tank.conf", "r")
	if not fileexsist then 
		restoredefaultconf()
	else
		fileexsist:close()
	end

	ok, chunk = pcall( loadfile, directory.."/tank.conf") -- load the chunk safely

	if ok and not chunk then
		winstate = "file \"tank.conf\" is invalid or not exist, loading defaults..."
		table.insert(confprocesstab,#confprocesstab + 1,"file \"tank.conf\" is invalid, loading defaults...")
	else
		ok, result = pcall(chunk) 
		if not ok then 
			winstate = "The following error happened: " .. tostring(result)
			table.insert(confprocesstab,#confprocesstab + 1,"The following error happened: " .. tostring(result))
		else
			if type(result) == "table" and result.menu_player1 and type (result.menu_player1) == "table" then
				assignkey ("up","up")
				assignkey ("down","down")
				assignkey ("left","left")
				assignkey ("right","right")
				assignkey ("action_shoot","shoot")
				assignkey ("pause","pause")
				if result.maps and type(result.maps) == "table" then
					local i = #maps +1
					for j,map in pairs(result.maps) do -- loading coustom maps
						ok, chunk = pcall( loadfile, directory.."/"..map)
						if ok and not chunk then
							winstate = "file \"..map..\" is invalid or not exist..."
							table.insert(confprocesstab,#confprocesstab + 1,"map file \""..map.."\" is invalid or not exist...")
						else
							maps[i] = map
							i = i+1
						end
					end
				else
					table.insert(confprocesstab,#confprocesstab + 1,"missing seting in tank.conf (maps)")
				end
				if result.sound and tonumber(result.sound) then
					if result.sound > 0 then
						soundon() 
					else
						soundoff()
					end
						
				else
					table.insert(confprocesstab,#confprocesstab + 1,"missing seting in tank.conf (sound), or wrong value")
				end
			else
				winstate = "unexpected table format in file \"tank.conf\""
				table.insert(confprocesstab,#confprocesstab + 1,"unexpected table format in file \"tank.conf\"")
			end
		end
	end 

restoretab = {
	{dysplay = "SELECT ACTION:"},
	{[mp1.shoot] = function()
		local defaultfile = io.open(savedir.."/tank.conf","r") 
		local text = defaultfile:read("*a")
		local newfile = io.open("tank.conf", "w")
		newfile:write(text)
		newfile:close()
		defaultfile:close()
		loadconfigfile()
	end, 
	dysplay = "RESTORE LATEST", 
	desc = "Press: "..mp1.shoot..(friendlyname[mp1.shoot] or "").." - to restore last correct tank.conf file."},
	{[mp1.shoot] = function()
		restoredefaultconf()
		loadconfigfile()
	end,
	dysplay = "RESTORE DEDAULT",
	desc = "Press: "..mp1.shoot..(friendlyname[mp1.shoot] or "").." - to restore default tank.conf file."},
	{[mp1.shoot]= function()
		startmenu()	
	end,
	dysplay = "CONTINUE",
	desc = "Press: "..mp1.shoot..(friendlyname[mp1.shoot] or "").." - to lunch menu without restoring tank.conf file."} 
}
suboptions = {
	{dysplay = "OPTIONS:"},
	{[mp1.shoot] = function()
		curmenu = dificulitytab
		menustate = 2
	end,
	dysplay = "DIFFICULITY",
	desc = "Press: "..mp1.shoot..(friendlyname[mp1.shoot] or "").." - to open difficulty menu"},
	{[mp1.left]= function()
		mapid = mapid - 1
		if mapid < 1 then mapid = #maps end
		setmapdrawtext(mapid)
		curmenu[menustate].dysplay = "MAP: "..mapdraw
	end,
	[mp1.right]= function()
		mapid = mapid + 1
	   	if mapid > #maps then mapid = 1 end
	   	setmapdrawtext(mapid)
		curmenu[menustate].dysplay = "MAP: "..mapdraw
	end,
	dysplay = "MAP: "..mapdraw,
	desc = "Select map using: "..mp1.left..(friendlyname[mp1.left] or "").." and "..mp1.right..(friendlyname[mp1.right] or "")},
	{dysplay = "GAMEMODE: Kill Them All",
	desc = "Planed feature"},
	{dysplay = "GAMEMODE OPTIONS",
	desc = "Planed feature"},
	{[mp1.shoot] = function()
		if playsound then
			soundoff()
			curmenu[menustate].dysplay = "SOUND: "..playsounddisplay
		else
			soundon()
			curmenu[menustate].dysplay = "SOUND: "..playsounddisplay
		end
	end,
	dysplay = "SOUND: "..playsounddisplay,
	desc = "Press: "..mp1.shoot..(friendlyname[mp1.shoot] or "").." - to toggle sound"},				
	{[mp1.shoot] = function()
		curmenu = menutab
		menustate = 2
	end,
	dysplay = "BACK",
	desc = "Press: "..mp1.shoot..(friendlyname[mp1.shoot] or "").." - to return to main menu"}				
	}
dificulitytab = {
	{dysplay = "DIFFICULITY:"},
	{[mp1.shoot]= function()
		nmenu = true
	end,
	[mp1.left]= function()
		local a = 1
		if nmenu then a = 10 end
		botn = botn - a
		if botn < 1 then botn = 1 end
		curmenu[menustate].dysplay = "MAX BOTS on map: "..botn
		curmenu[menustate].botn = botn
	end,
	[mp1.right]= function()
		local a = 1
		if nmenu then a = 10 end
		botn = botn + a
		curmenu[menustate].dysplay = "MAX BOTS on map: "..botn
		curmenu[menustate].botn = botn
	end,
	botn = botn,
	dysplay = "MAX BOTS on map: "..botn,
	desc = "Set amount using: "..mp1.left..(friendlyname[mp1.left] or "").." and "..mp1.right..(friendlyname[mp1.right] or "").."; Boost x10 holding: "..mp1.shoot..(friendlyname[mp1.shoot] or "")},
	{[mp1.shoot]= function()
		nmenu = true
	end,
	[mp1.left]= function()
		local a = 1
		if nmenu then a = 10 end
		botleft = botleft - a
		if botleft < 1 then botleft = 1 end
		curmenu[menustate].dysplay = "Starting amount of BOTS: "..botleft
		curmenu[menustate].botleft = botleft
	end,
	[mp1.right]= function()
		local a = 1
		if nmenu then a = 10 end
		botleft = botleft + a
		curmenu[menustate].dysplay = "Starting amount of BOTS: "..botleft
		curmenu[menustate].botleft = botleft
	end,
	botleft = botleft,
	dysplay = "Starting amount of BOTS: "..botleft,
	desc = "Set amount using: "..mp1.left..(friendlyname[mp1.left] or "").." and "..mp1.right..(friendlyname[mp1.right] or "").."; Boost x10 holding: "..mp1.shoot..(friendlyname[mp1.shoot] or "")},
	{[mp1.shoot]= function()
		nmenu = true
	end,
	[mp1.left]= function()
		local a = 1
		if nmenu then a = 10 end
		botincreeseamount = botincreeseamount - a
		if botincreeseamount < 1 then botincreeseamount = 1 end
		curmenu[menustate].dysplay = "New BOTS per map: "..botincreeseamount
		curmenu[menustate].botincreeseamount = botincreeseamount
	end,
	[mp1.right]= function()
		local a = 1
		if nmenu then a = 10 end
		botincreeseamount = botincreeseamount + a
		curmenu[menustate].dysplay = "New BOTS per map: "..botincreeseamount
		curmenu[menustate].botincreeseamount = botincreeseamount
	end,
	botincreeseamount = botincreeseamount,
	dysplay = "New BOTS per map: "..botincreeseamount,
	desc = "Set amount using: "..mp1.left..(friendlyname[mp1.left] or "").." and "..mp1.right..(friendlyname[mp1.right] or "").."; Boost x10 holding: "..mp1.shoot..(friendlyname[mp1.shoot] or "")},
	{[mp1.shoot] = function()
		curmenu = suboptions
		menustate = 2
	end,
	dysplay = "BACK",
	desc = "Press: "..mp1.shoot..(friendlyname[mp1.shoot] or "").." - to return to options menu"}				
}
startgametab = {
	{dysplay = "START GAME:"},
	{[mp1.shoot] = function()
		loadgame()
	end,
	dysplay = "RESUME",
	desc = "Press: "..mp1.shoot..(friendlyname[mp1.shoot] or "").." - to resume last session"},
	{[mp1.shoot] = function()
		botincreese = botincreeseamount
		startgame("new",botleft)
	end,
	dysplay = "START GAME",
	desc = "Press: "..mp1.shoot..(friendlyname[mp1.shoot] or "").." - to start the game.\nGame controls: moving: "..mp1.up..(friendlyname[mp1.up] or "").."; "..mp1.down..(friendlyname[mp1.down] or "")..";"..mp1.left..(friendlyname[mp1.left] or "").."; "..mp1.right..(friendlyname[mp1.right] or "")..";\nshoting - "..mp1.shoot..(friendlyname[mp1.shoot] or "").." (You may change it in tank.conf)"},
}		
menutab = {
	{dysplay = "MAIN MENU:"},
	{[mp1.shoot] = function()
		local fileexsist =io.open(savedir.."/tank.sav", "r")
		if fileexsist then
			curmenu = startgametab
			menustate = 2
			fileexsist:close()
		else
			botincreese = botincreeseamount
			startgame("new",botleft)
		end
	end,
	dysplay = "START GAME",
	desc = "Press: "..mp1.shoot..(friendlyname[mp1.shoot] or "").." - to start the game.\nGame controls: moving: "..mp1.up..(friendlyname[mp1.up] or "").."; "..mp1.down..(friendlyname[mp1.down] or "")..";"..mp1.left..(friendlyname[mp1.left] or "").."; "..mp1.right..(friendlyname[mp1.right] or "")..";\nshoting - "..mp1.shoot..(friendlyname[mp1.shoot] or "").." (You may change it in tank.conf)"},
	{[mp1.shoot] = function()
		curmenu = suboptions
		menustate = 2
	end,
	dysplay = "OPTIONS",
	desc = "Press: "..mp1.shoot..(friendlyname[mp1.shoot] or "").." - to enter options sub menu."},
	{[mp1.shoot]= function()
		gamestate = 6		--
	end,
	dysplay = "HIGH SCORES",
	desc = "Press: "..mp1.shoot..(friendlyname[mp1.shoot] or "").." - to see top 10 scores"},
	{[mp1.shoot]= function()
		--starteditor()
	end,
	dysplay = "Start Map Editor",
	desc = "Planed feature"},
	{[mp1.shoot]= function()
		love.event.push('quit')
	end,
	dysplay = "QUIT",
	desc = "Press: "..mp1.shoot..(friendlyname[mp1.shoot] or "").." - to quit the game"}
}
navtab = {
	[mp1.up] = function()
		menustate = menustate - 1
		if menustate < 2 then menustate = #curmenu end
	end,
	[mp1.down] = function()
		menustate = menustate + 1
		if menustate > #curmenu then menustate = 2 end
	end,
	[mp1.pause] = function()
		if backinmenutab[curmenu] then backinmenutab[curmenu]() end
	end,
        desc = "Menu navigation: "..mp1.up..(friendlyname[mp1.up] or "")..", "..mp1.down..(friendlyname[mp1.down] or "")..", "..mp1.pause..(friendlyname[mp1.pause] or "")
}
pausemenutab = {
	{dysplay = "PAUSE..."},
	{[mp1.shoot] = function()
		gamestate = 2
	end,
	dysplay = "RESUME GAME",
	desc = "Press: "..mp1.shoot..(friendlyname[mp1.shoot] or "").." - to resume the game"},
	{[mp1.shoot] = function()
		sawegame()
		startmenu()
	end,
	dysplay = "MAIN MENU",
	desc = "Press: "..mp1.shoot..(friendlyname[mp1.shoot] or "").." - to return to main menu"}
}
movetab = {
	[mp1.up] = function()
	   if player.slip ==0 then
		antycamp (player,0,1)
	   	isup = true
	   	isdown = false
	   	isleft = false
	   	isright = false
	   	player.grid_dir = 0
	  	pstate = 0
		rotOfsetElement(player)
		--souride:setLooping(true)
		--love.audio.play(souride)
	   end
	end,
	[mp1.down] = function()
	   if player.slip ==0 then
		antycamp (player,0,-1)
	   	isdown = true
	   	isup = false
	   	isleft = false
	  	isright = false
	  	player.grid_dir = 2
	  	pstate = 0
	  	rotOfsetElement(player)
		--souride:setLooping(true)
		--love.audio.play(souride)
	   end
	end,
	[mp1.left]= function()
	   if player.slip ==0 then
		antycamp (player,1,0)
	   	isleft = true
	   	isup = false
	   	isdown = false
	 	isright = false
	   	player.grid_dir = 3
	   	pstate = 0
	   	rotOfsetElement(player)
		--souride:setLooping(true)
		--love.audio.play(souride)
	   end
	end,
	[mp1.right]= function()
	   if player.slip ==0 then
		antycamp (player,-1,0)
	   	isright = true
	   	isup = false
	   	isdown = false
	   	isleft = false
	   	player.grid_dir = 1
	   	pstate = 0
	   	rotOfsetElement(player)
		--souride:setLooping(true)
		--love.audio.play(souride)
	   end
	end,
	[mp1.shoot] = function()
		if not player.bullet then
			if playsound then
				soushoot:stop()
				love.audio.play(soushoot)
			end
			local abullet = createBullet("pla",player.grid_x,player.grid_y,player.direction)
			player.bullet = true
			bullettab["pla"] = abullet
			rotOfsetBullet(abullet)
		end
	end,
	[mp1.pause] = function()
		gamestate = 3
		curmenu = pausemenutab 
		menustate = 2
		if playsound then
			souride:stop()
		end
	end
}
backinmenutab = {
	[pausemenutab] = function()
		menustate = #pausemenutab
	end,
	[menutab] = function()
		menustate = #menutab
	end,
	[dificulitytab] = function()
		curmenu = suboptions
		menustate = 2
	end,
	[suboptions] = function()
		curmenu = menutab
		menustate = 2
	end
}
	if #confprocesstab == 0 then
		startmenu()
		local file = io.open("tank.conf", "r")
		local text = file:read("*a")
		love.filesystem.write("tank.conf",text)
		file:close()
	else
		table.insert(confprocesstab,1,"Processing \"tank.conf\" file failed:")
		table.insert(confprocesstab,#confprocesstab + 1,"Game will use default settings (if necesery)")
		table.insert(confprocesstab,#confprocesstab + 1,"Press any key to continue")
	end
end

math.randomseed(os.time())
math.random()
math.random()

function sawegame()
	local savetab = {map=map,dynamicmap=dynamicmap,spawnmap=spawnmap,bottab=bottab,bullettab=bullettab,player=player,mapid=mapid,botn=botn,botleft=botleft,botincreese=botincreese,spottab=spottab}
	local savetext = "return "..table.tostring(savetab)
	savetext = string.gsub (savetext,"={","={   \n") 
	savetext = string.gsub (savetext,"},","},   \n")
	local newfile = io.open(savedir.."/tank.sav", "w")
	newfile:write(savetext)
	newfile:close()
end

function loadgame()
	local func = loadfile(savedir.."/tank.sav")
	local tab = func()
	map= tab.map
	dynamicmap= tab.dynamicmap
	spawnmap= tab.spawnmap
	bottab= tab.bottab	
	bullettab= tab.bullettab
	player= tab.player
	mapid= tab.mapid
	botn= tab.botn
	botleft= tab.botleft
	spottab = tab.spottab
	botincreese= tab.botincreese
	setmapdrawtext(mapid) --(edit-30-03-12)
	suboptions[3].dysplay = "MAP: "..mapdraw --(edit-30-03-12)
	boundcamera()
	for i,bot in pairs(bottab) do
		bot.decisionlag = 0
		bot.dete = 0
		--bot.soushoot = love.audio.newSource( "shoot.mp3")
	end 
	--[[for i,bullet in pairs(bullettab) do
		bullet.souhit = love.audio.newSource( "hit.mp3")
	end]]
	gamestate = 2
end

function love.quit()
	if gamestate == 2 or gamestate == 3 then
		sawegame()
	end
end

function startgame(atype,botsleft) -- starting the game
	--souride:setLooping(true)
	map = {}
	dynamicmap = {}
	bottab = {}
	bullettab = {}
	local startx = 0
	local starty = 0
	spawnmap = {}
	spottab = {}
	local jn = 0
	local mapname = maps[mapid]
	if tonumber(mapdraw) then
		ok, chunk = pcall( love.filesystem.load, mapname)
	else
		ok, chunk = pcall( loadfile, directory.."/"..mapname)
	end
	if not ok and type(chunk)=="string" then --(edit-30-03-12)
		winstate = "map file \""..mapname.."\" is invalid or not exist..."
		if atype == "next" then
			return nextmap()
		end
	else
		map = chunk()
		for i=1,#map do
			dynamicmap[i] = {}
			for j=1,#map[1] do 
				dynamicmap[i][j] = 0
				if map[i][j] == -1 then
					startx = j
					starty = i
					testtest = -1
				elseif map[i][j] == -2 then
					jn = jn+1
					spawnmap[jn] = {x=j,y=i}
					testtest = -2
				elseif map[i][j] == 9 or map[i][j] == 10 then
					createSpoot("map", j, i)
				end
			end
		end
		if atype == "next" then
			player.grid_x = 32*startx
			player.grid_y = 32*starty
			player.act_x = 32*startx
			player.act_y = 32*starty
		elseif atype == "new" then
			player = createPlayer(startx,starty)
		end 
		local j = 1
		botn = math.min(botn,botsleft)
    		for i=1,botn do
			local maxhp = math.random(1,math.max(player.level-1,1))
			local bot = createBot(spawnmap[j],maxhp,maxhp,i)
    			if j == jn then j = 1 else j = j+1 end
      			bottab[i] = bot
   		end
    	--botleft = botn
 	boundcamera()
    	gamestate = 2
	end
end

function boundcamera()
	local x = #map[1]*32-width+32*5
    	if x < 0 then x = 0 end
    	local y = #map*32-height+32*2
    	if y < 0 then y = 0 end
    	camera:setBounds(0, 0, x, y)
end

local text = ""
local text2 = ""
local pstate = 0
local pdm = 0

function startmenu() -- loading the menu
	gamestate = 1
	curmenu = menutab
	menustate = 2
	bottab = {}
	bullettab = {}
	botn = dificulitytab[2].botn  -- warning
	botleft = dificulitytab[3].botleft --warning
	botincreeseamount = dificulitytab[4].botincreeseamount
end

function createPlayer(startx,starty) -- new player element
	return {
		atype = "player",
        	grid_x = 32*startx,
       		grid_y = 32*starty,
        	act_x = 32*startx,
        	act_y = 32*starty,
		draw_x = 0,
        	draw_y = 0,
		score = 0,
		ismoving = {x=false,y=false,overal=false,overalstate=true},
		basespeed = 2,
        	speed = 2,
		grid_dir = 0,
		direction = 0,
		bullet = false,
		hp = 1,
		maxhp = 1,
		kills = 0,
		level = 0,
		nextlevel = 5,
		slip = 0,
		slipstate = false,
		name = ""
               }
end

function createBot (spawn,ahp,amaxhp,i) -- new enemy element
	return {
		atype = "bot",
		i = i,
	    	grid_x = spawn.x*32,
        	grid_y = spawn.y*32,
        	act_x = spawn.x*32,
        	act_y = spawn.y*32,
		ismoving = {x=false,y=false,overal=false,overalstate=true},
		draw_x = 0,
        	draw_y = 0,
		basespeed = 2,
        	speed = 2,
	    	direction = 0,
		grid_dir = 0,
		bullet = false,
		dete = 0,
		randomdt = 0,
		randominterval = 5.5,
		decisionlag = 0,
		hp = ahp,
		maxhp = amaxhp,
		slip = 0
               }
end

function createBullet(id,x,y,dire) --new projectale element
	return {
		atype = "bullet",
		botid = id,
		grid_x = x,
		grid_y = y,
		act_x = x,
		act_y = y,
		draw_x = 0,
		acurat = false,
		ismoving = {x=false,y=false,overal=false,overalstate=true},
		draw_y = 0,
		speed = 4,
		dir = dire,
		range = 0
	       }
end

function createSpoot(ori, px, py) -- ori: "map" "fir" "law" "bot" "timeout"
	local id = (py-1)*#map[1]+px
	local block = map[py][px]
	local count = false
	local typ = "permfir"
	if ori == "map" then
		count = false
		if block == 10 then
			typ = "permfir"
		else
			typ = "permlaw"
		end
	elseif ori == "timeout" then
		block = 0
		count = 6
		typ = "fir"
	else
		if spottab[id] and spottab[id].typ == "permfir" then
			block = 9
			count = false
			typ = "permlaw"
		elseif spottab[id] and spottab[id].typ == "permlaw" then
			block = 9
			count = false
			typ = "permlaw"
		elseif spottab[id] and spottab[id].typ == "fir" then
			block = 9
			count = 6
			typ = "law"
		elseif spottab[id] and spottab[id].typ == "law" then
			block = 9
			count = 6
			typ = "law"
		elseif block == 8 then
			block = 5
			count = 6
			typ = "fir"
		elseif block == 7 then
			block = 10
			count = false
			typ = "permfir"
		elseif block == 6 then
			block = 1
			count = 2
			typ = "fir"
		elseif block == 5 then
			block = 4
			count = 1
			typ = "fir"
		elseif block == 4 then
			block = 3
			count = 1
			typ = "fir"
		elseif block == 3 then
			block = 3
			count = 1
			typ = "fir"
		elseif block == 2 then
			return
		elseif block == 1 then
			block = 7
			count = 2
			typ = "fir"
		elseif block < 1 then
			block = 0
			count = 6
			typ = "fir"
		end

	end
	if typ == "fir" or typ == "permfir" then
		map[py][px] = 10
	else	
		map[py][px] = 9
	end
	local spot = {
		ori = ori,
		typ = typ,
		block = block,
		x = px,
		y = py,
		count = count,

	}
	spottab[id]=spot
end

local antycampmap = {}
function savedynamic(bot,x,y) -- colisions of tanks
	dynamicmap[(bot.grid_y / 32)+y][(bot.grid_x / 32)+x] = 0
	if bot.atype == "player" then
		dynamicmap[(bot.grid_y / 32)][(bot.grid_x / 32)] = 3
		antycamp (bot,x,y)
	else
		dynamicmap[(bot.grid_y / 32)][(bot.grid_x / 32)] = 1
	end
end
function antycamp (bot,x,y) -- aditional colisions for layer
		for i,tab in pairs(antycampmap) do
			if tab and type(tab) == "table" then
				if dynamicmap[tab.y] and dynamicmap[tab.y][tab.x] == 2 then
						dynamicmap[tab.y][tab.x] = 0
				end
			end
		end
		if dynamicmap[(bot.grid_y / 32)-y] and dynamicmap[(bot.grid_y / 32)-y][(bot.grid_x / 32)-x] == 0 then
			dynamicmap[(bot.grid_y / 32)-y][(bot.grid_x / 32)-x] = 2		
			if dynamicmap[(bot.grid_y / 32)-y*2] and dynamicmap[(bot.grid_y / 32)-y*2][(bot.grid_x / 32)-x*2] == 0 then
				dynamicmap[(bot.grid_y / 32)-y*2][(bot.grid_x / 32)-x*2] = 2
				if dynamicmap[(bot.grid_y / 32)-y*3] and dynamicmap[(bot.grid_y / 32)-y*3][(bot.grid_x / 32)-x*3] == 0 then
					dynamicmap[(bot.grid_y / 32)-y*3][(bot.grid_x / 32)-x*3] = 2
				end
			end
		end
		antycampmap = {{x=(bot.grid_x / 32)-x,y=(bot.grid_y / 32)-y},
			       {x=(bot.grid_x / 32)-x*2,y=(bot.grid_y / 32)-y*2},
			       {x=(bot.grid_x / 32)-x*3,y=(bot.grid_y / 32)-y*3}}
end
--local isplayermoving = {x=false,y=false,overal=false,overalstate=true}
function setisplayermowing(elem,state,dir)
    if elem.ismoving then
	elem.ismoving[dir] = state
	if not elem.ismoving.x  and not elem.ismoving.y then
		elem.ismoving.overal=false
	else
		elem.ismoving.overal=true
	end
	if elem.ismoving.overal and elem.ismoving.overalstate then
		elem.ismoving.overalstate = false
		--souride:setLooping(true)
		if playsound and elem.atype == "player" then
			love.audio.play(souride)
		end
	elseif not elem.ismoving.overal and not elem.ismoving.overalstate then
		elem.ismoving.overalstate = true
		--souride:setLooping(false)
		if playsound and elem.atype == "player" then
			souride:stop()
		end
	end
   end
end
function moveElement(elem,dt,dir) --smoudh moving
   if not dir then
	moveElement(elem,dt,"x")
	moveElement(elem,dt,"y")
   else
  	 if elem["act_"..dir] - elem["grid_"..dir] < 2 and elem["grid_"..dir] - elem["act_"..dir] < 2 then
 	     elem["act_"..dir] = elem["grid_"..dir]
	     setisplayermowing(elem,false,dir)
 	  elseif  not (elem["act_"..dir] - elem["grid_"..dir] < 2) then
 	     elem["act_"..dir] = elem["act_"..dir] - 32*elem.speed*dt
	     setisplayermowing(elem,true,dir)
 	  elseif not (elem["grid_"..dir] - elem["act_"..dir] < 2) then
 	     elem["act_"..dir] = elem["act_"..dir] + 32*elem.speed*dt
	     setisplayermowing(elem,true,dir)
 	  end
   end
end

function moveGrid(elem,dir1,dir2,dir3,dir4) -- actual position change
	if elem.act_y == elem.grid_y and elem.act_x == elem.grid_x  then
        	elem["grid_"..dir1] = elem["grid_"..dir1] + dir2
		if elem.atype == "bullet" then
			elem.range = elem.range + 1
		else
			elem.direction = elem.grid_dir
			savedynamic(elem,dir3,dir4)
			rotOfsetElement(elem)
		end
	end
end

function rotOfsetElement(elem) -- rotations for tanks
	elem.direction = elem.grid_dir
	if elem.direction == 2 then 
		elem.draw_x = 32
		elem.draw_y = 32
	elseif elem.direction == 3 then
		elem.draw_y = 32
		elem.draw_x = 0
	elseif elem.direction == 1 then
		elem.draw_x = 32
		elem.draw_y = 0
	elseif elem.direction == 0 then
		elem.draw_x = 0
		elem.draw_y = 0
	end
end

function rotOfsetBullet(bullet) -- rotations for projectals
	if bullet.dir  == 0 then
		bullet.draw_x = 16 
		bullet.draw_y = 0 
	elseif bullet.dir == 1 then
		bullet.draw_x = 32 
		bullet.draw_y = 16 
	elseif bullet.dir == 2 then
		bullet.draw_x = 16 
		bullet.draw_y = 32 
	else
		bullet.draw_y = 16 
		bullet.draw_x = 0 
	end
end

local updatefunc = {} 
local cursorinterval = 0.8
local cursordt = 0
local cursordysplay = ""
local cursorstate = true
updatefunc[7] = function(dt)
	cursordt = cursordt + dt
	if cursordt > cursorinterval then
		cursordt = 0
		cursorstate = not cursorstate
		if cursorstate then
			cursordysplay = ""
		else
			cursordysplay = "|"
		end
	end	
end
--[[function stopridesound()
	souride:setLooping(false)
	souride:stop() 
end]]

local animinrerval = 0
local animduration = 1.2
local animcorect = 0
local firspreedtimer = 12

updatefunc[2] = function (dt) -- game
	for i,spot in pairs (spottab) do
		if spot.count then
			spot.count = spot.count - dt
			if spot.count < 0 then
				if spot.typ == "law" then
					createSpoot("timeout", spot.x, spot.y)
				else
					map[spot.y][spot.x] = spot.block
					spottab[i] = nil
				end
			end 
		end
	end	
	firspreedtimer = firspreedtimer - dt
	if firspreedtimer < 0 then
		firspreedtimer = 12
		for i,spot in pairs (spottab) do
			if spot.typ == "law" or spot.typ == "permlaw" then
				local rand = math.random(1,2)
				if rand == 1 then
					rand = math.random(0,3)
					if rand == 0 then createSpoot("law", spot.x ,spot.y - 1)
					elseif rand == 2 then createSpoot("law", spot.x, spot.y + 1)
					elseif rand == 3 then createSpoot("law", spot.x - 1, spot.y)
					elseif rand == 1 then createSpoot("law", spot.x + 1, spot.y) end
				end
			else
				local rand = math.random(0,9)
				if rand == 0 then
					rand = math.random(0,3)
					if rand == 0 then createSpoot("fir", spot.x ,spot.y - 1)
					elseif rand == 2 then createSpoot("fir", spot.x, spot.y + 1)
					elseif rand == 3 then createSpoot("fir", spot.x - 1, spot.y)
					elseif rand == 1 then createSpoot("fir", spot.x + 1, spot.y) end
				end
			end
		end
	end
	animinrerval = animinrerval + dt
	if animinrerval > animduration then
		animinrerval = 0
		scalexbus = 0 - scalexbus
		if scalexbus > 0 then
			animcorect = 0
		else
			animcorect = 32
		end
	end 
	camera:setPosition(player.act_x - width / 2, player.act_y - height / 2)
	moveElement(player,dt)
    	text = dt
	if player.ismoving then
    	  if (not player.ismoving.overal) and isup and testBotMap(player,0, -1) then moveGrid(player,"y",-32,0,1) end
    	  if (not player.ismoving.overal) and isdown and testBotMap(player,0, 1) then moveGrid(player,"y",32,0,-1) end
    	  if (not player.ismoving.overal) and isleft and testBotMap(player,-1, 0) then moveGrid(player,"x",-32,1,0) end
    	  if (not player.ismoving.overal) and isright and testBotMap(player,1, 0) then moveGrid(player,"x",32,-1,0)  end
	end
    	for i,bot in pairs( bottab )do	
		bot.randomdt = bot.randomdt + dt
    		if bot.randomdt >= bot.randominterval and bot.slip == 0 then
			bot.randomdt = 0
			bot.grid_dir = math.random(0,3)
			rotOfsetElement(bot)
    		end
		if (not bot.ismoving.overal) and bot.grid_dir == 0 and testBotMap(bot,0, -1) then moveGrid(bot,"y",-32,0,1)
		elseif (not bot.ismoving.overal) and bot.grid_dir == 2 and testBotMap(bot,0, 1) then moveGrid(bot,"y",32,0,-1)
		elseif (not bot.ismoving.overal) and bot.grid_dir == 3 and testBotMap(bot,-1, 0) then moveGrid(bot,"x",-32,1,0)
		elseif (not bot.ismoving.overal) and bot.grid_dir == 1 and testBotMap(bot,1, 0) then moveGrid(bot,"x",32,-1,0)
		elseif (not bot.ismoving.overal) and bot.act_y == bot.grid_y and bot.act_x == bot.grid_x then
			local atime = love.timer.getTime()
			if (atime - bot.decisionlag) > 0.32 then
				bot.decisionlag = atime
				bot.grid_dir = math.random(0,3)
				rotOfsetElement(bot)
			end
		end
		moveElement(bot,dt)
	    
        	if not bot.bullet then
			local atime = love.timer.getTime()
			if (atime - bot.dete) > 1 then
				bot.dete = atime
				if playsound and isElementOnScreen(bot.act_x,bot.act_y) then
					local distance = (((bot.act_x-player.act_x)^2)+((bot.act_y-player.act_y)^2))^0.5
					if distance < 15*32 then
						botsoushoot:stop()
						love.audio.play(botsoushoot)
					end
				end
				local abullet = createBullet(i,bot.grid_x,bot.grid_y,bot.direction)
				bot.bullet = true
				bullettab[i] = abullet
				rotOfsetBullet(abullet)
			end
		end
		--if bullettab["pla"] and bullettab["pla"].grid_x == bot.grid_x and bullettab["pla"].grid_y == bot.grid_y then
		if bullettab["pla"] and bullettab["pla"].acurat and didbullethit(bullettab["pla"],bot) then
			bullettab["pla"] = nil
			player.bullet = false
			damagebot(bot)
			
		end
	end
	for i,bullet in pairs(bullettab)  do
		
		if (not bullet.ismoving.overal) and bullet.dir == 0 and testbulMap(bullet,0,-1,0,-2,-1,-1,1,-1) then moveGrid(bullet,"y",-32,0,0)
		elseif (not bullet.ismoving.overal) and bullet.dir == 2 and testbulMap(bullet,0,1,0,2,1,1,-1,1) then moveGrid(bullet,"y",32,0,0)
		elseif (not bullet.ismoving.overal) and bullet.dir == 3 and testbulMap(bullet,-1,0,-2,0,-1,1,-1,-1) then moveGrid(bullet,"x",-32,0,0)
		elseif (not bullet.ismoving.overal) and bullet.dir == 1 and testbulMap(bullet,1,0,2,-2,1,-1,1,1) then moveGrid(bullet,"x",32,0,0)
		elseif (not bullet.ismoving.overal) then
			if i ~= "pla" and bottab[i] then
				bottab[i].bullet = false
			elseif i == "pla" then
				player.bullet = false
			end
			if playsound and isElementOnScreen(bullet.act_x,bullet.act_y) then
					local distance = (((bullet.act_x-player.act_x)^2)+((bullet.act_y-player.act_y)^2))^0.5
					if distance < 15*32 then
						bulletsouhit:stop()
						love.audio.play(bulletsouhit)
						--bulletsouhit = nil
					end
				end
			--love.audio.play(bullet.souhit)
			
			bullettab[i] = nil
	    	end
		if bullet.range >= 12 then 
			if i ~= "pla" and bottab[i] then
				bottab[i].bullet = false
			elseif i == "pla" then
				player.bullet = false
			end
			bullettab[i] = nil
		end
		moveElement(bullet,dt)
		--if bullet.grid_x == player.grid_x and bullet.grid_y == player.grid_y and i ~= "pla" then
		if i ~= "pla" and bullet.acurat and didbullethit(bullet,player) then
			bullettab[i] = nil
			if i ~= "pla" and bottab[i] then
				bottab[i].bullet = false
			end
			damageplayer ()
		else
			
		end
	 end
end

function damagebot(bot,am)
			bot.hp = bot.hp - (am or 1)
			if not am then player.score = player.score + 3 end
			if playsound then
				souhit:stop()
				love.audio.play(souhit)
			end
			if bot.hp <= 0 then
				botleft = botleft -1
				createSpoot("bot", bot.grid_x/32, bot.grid_y/32)
				if not am then player.score = player.score + 2 end
				if playsound then
					souboom:stop()
					love.audio.play(souboom)
				end
				dynamicmap[(bot.grid_y / 32)][(bot.grid_x / 32)] = 0
				if not am then
					player.kills = player.kills + 1
					if player.kills >= player.nextlevel then 
						player.level = player.level + 1
						player.maxhp = player.maxhp + 1
						player.hp = player.maxhp
						player.nextlevel = math.floor(player.nextlevel*1.5 + 3)
						for i,bot in pairs(bottab) do
							bot.maxhp = math.random(1,math.max(player.level-1,1))
							bot.hp = bot.maxhp
						end
					end		
				end
				if botleft < botn then
					botn = botleft
		    			bottab[bot.i] = nil
					if botleft == 0 then
			   			winstate = "VICTORY"
						if playsound then
							souride:stop()
						end
						player.slip = 0
						restorecontroll (player)
						screentimer = 5
			  			gamestate = 4
					end
				else
					local spawn = math.random(1,#spawnmap)
					bot.grid_x = spawnmap[spawn].x*32
					bot.grid_y = spawnmap[spawn].y*32
        				bot.act_x = spawnmap[spawn].x*32
					bot.act_y = spawnmap[spawn].y*32
					bot.maxhp = math.random(1,math.max(player.level-1,1))
					bot.hp = bot.maxhp
				end
			end
end

function damageplayer (am)
		player.hp = player.hp - (am or 1)
			if playsound then
				souhit:stop()
				love.audio.play(souhit)
			end
			if player.hp <= 0 then
				winstate = "FAIL"
				if playsound then
					souride:stop()
					souboom:stop()
					love.audio.play(souboom)
				end
				player.slip = 0
				restorecontroll (player)
				screentimer = 5
				gamestate = 5
				love.filesystem.remove("tank.sav")
			end
end

function screentimerfunc(dt)
	if tonumber(screentimer) and tonumber(screentimer) > 0 then
		screentimer = screentimer - dt
		screendt = math.floor(screentimer) + 1
	else
		screendt = "Press any key to continue"
	end
end

updatefunc[4] = function (dt)
	screentimerfunc(dt)
end

updatefunc[5] = function (dt)
	screentimerfunc(dt)
end

function love.update(dt)
	if updatefunc[gamestate] then
		updatefunc[gamestate](dt)
	end
end

curmenu = menutab

local drawfunc = {}

drawfunc[0] = function() -- debug
	love.graphics.setColor( 0, 0, 0)
	for i,error in pairs(confprocesstab) do
		love.graphics.print(error or "error", 128, 10+i*12)
	end
end

drawfunc[1] = function() --menu
	love.graphics.setColor( 250, 150, 1)
	love.graphics.rectangle("fill", 0, height - 128, width,128)
	love.graphics.rectangle("fill", width/2 -  4 * 32,48, 8*32,32)
	love.graphics.setColor( 0, 0, 0)
	love.graphics.print(navtab.desc or "error", 128, height - 120)
	love.graphics.print(curmenu[menustate].desc or "error", 128, height - 108)
	love.graphics.setColor( 200, 100, 1)
    	love.graphics.rectangle("fill",width/2 -  4 * 32, 16 + menustate * 32,8 * 32, 32)
    	love.graphics.setColor( 0, 0, 0)
	for i, node in pairs(curmenu) do
		love.graphics.print(node.dysplay or "error", width/2 -  3 * 32, 32 + i * 32 - 10)
	end

end
	
drawfunc[6] = function() -- dysplay score
	love.graphics.setColor( 250, 150, 1)
	love.graphics.rectangle("fill", width/2 -  4 * 32,48, 8*32,#scoretab*32+32)
	local pair = false
	love.graphics.setColor( 0, 0, 0)
	love.graphics.print("HIGH SCORES:", width/2 -  3 * 32, 2*32)
	love.graphics.setColor( 200, 100, 1)
	for i=1, #scoretab do
		if pair then
			love.graphics.rectangle("fill",width/2 -  4 * 32, 16 + i * 32,8 * 32, 32)
		end
		pair = (not pair)
	end
	love.graphics.setColor( 0, 0, 0)
	for i=1, #scoretab do
		local name = ""
		local ascore = ""
		for n,s in pairs(scoretab[i]) do
			name = n
			ascore = s
		end
		love.graphics.print(i..") "..name..": "..ascore, width/2 -  3 * 32, 32 + i * 32 +22)
	end
end

drawfunc[7] = function() -- dysplay score
	love.graphics.setColor( 250, 150, 1)
	love.graphics.rectangle("fill", width/2 -  4 * 32,48, 8*32,32)
	local pair = false
	love.graphics.setColor( 0, 0, 0)
	love.graphics.print("ENTER YOUR NAME:", width/2 -  3 * 32, 2*32)
	love.graphics.setColor( 200, 100, 1)
	love.graphics.rectangle("fill",width/2 -  4 * 32, 48+32,8 * 32, 32)
	love.graphics.setColor( 0, 0, 0)
	love.graphics.print(player.name..cursordysplay, width/2 -  3 * 32, 2 * 32 +22)

end

drawfunc[2] = function() --game
	camera:set()
	for y=1, #map do
		for x=1, #map[y] do
			if  isElementOnScreen(x*32,y*32) then
				if map[y][x] == 1 then
					love.graphics.draw( imagewat, x*32+animcorect, y*32, 0, scalexbus, scaley, 0, 0 )
				elseif map[y][x] == 2 then
					love.graphics.draw( imagewall, x*32, y*32, 0, scalex, scaley, 0, 0 )
				elseif map[y][x] == 3 then
					love.graphics.draw( imagebri1, x*32, y*32, 0, scalex, scaley, 0, 0 )
				elseif map[y][x] == 4 then
					love.graphics.draw( imagebri2, x*32, y*32, 0, scalex, scaley, 0, 0 )
				elseif map[y][x] == 5 then
					love.graphics.draw( imagebri3, x*32, y*32, 0, scalex, scaley, 0, 0 )
				elseif map[y][x] == 6 then
					love.graphics.draw( imageice, x*32, y*32, 0, scalex, scaley, 0, 0 )
				elseif map[y][x] == 8 then
					love.graphics.draw( imagemud, x*32+animcorect, y*32, 0, scalexbus, scaley, 0, 0 )	
				elseif map[y][x] == 9 then
					love.graphics.draw( imagelaw, x*32+animcorect, y*32, 0, scalexbus, scaley, 0, 0 )	
           		end
		 	end
        end
    end
	love.graphics.draw( imageplayer,player.act_x + player.draw_x,player.act_y + player.draw_y, math.rad(player.direction*90), scalex, scaley, 0, 0 )
	love.graphics.setColor( 0, 0, 0)
	love.graphics.print("HP: "..player.hp.."/"..player.maxhp, player.act_x, player.act_y-15)
	love.graphics.setColor( 255, 255, 255)
	--love.graphics.print("         "..love.timer.getFPS()..", "..text2, player.act_x, player.act_y-20)
    	for i,bot in pairs( bottab )do
	  	if isElementOnScreen(bot.act_x,bot.act_y) then
			love.graphics.draw( imagebot,bot.act_x + bot.draw_x,bot.act_y + bot.draw_y, math.rad(bot.direction*90), scalex, scaley, 0, 0 )
			love.graphics.setColor( 0, 0, 0)
			love.graphics.print("HP: "..bot.hp.."/"..bot.maxhp, bot.act_x, bot.act_y-15)
			love.graphics.setColor( 255, 255, 255)
	  	end
    	end
	for i,bullet in pairs(bullettab)  do
	  	if isElementOnScreen(bullet.act_x,bullet.act_y) then
			love.graphics.circle( "fill",bullet.act_x + bullet.draw_x,bullet.act_y + bullet.draw_y, 6, 10 )
	  	end
	end
	for y=1, #map do
		for x=1, #map[y] do
			if  isElementOnScreen(x*32,y*32) then
				if map[y][x] == 7 then
					love.graphics.draw( imagebus, x*32, y*32, 0, scalex, scaley, 0, 0 )
				elseif map[y][x] == 10 then
					love.graphics.draw( imagefir, x*32+animcorect, y*32, 0, scalexbus, scaley, 0, 0 )
				end
			end
		end
	end
    	love.graphics.setColor( 255, 255, 255, 150)
	--[[for y=1, #dynamicmap do
        	for x=1, #dynamicmap[y] do
            		if dynamicmap[y][x] == 2 then
               			love.graphics.rectangle("fill", x * 32, y * 32, 32, 32)
            		end
        	end
   	 end]]
    camera:unset()
	love.graphics.setColor( 1, 100, 255,230)
   	love.graphics.rectangle("fill",width -  4 * 32, height -8 * 32,4 * 32, 8 * 32)
   	love.graphics.setColor( 30, 1, 1)
	love.graphics.print("FPS: "..love.timer.getFPS(), width -  4 * 32, height -12 * 20)
	love.graphics.print("SCORE: "..player.score, width -  4 * 32, height -8 * 20)
   	love.graphics.print("Bullet: "..tostring(not player.bullet), width -  4 * 32, height -7 * 20)
	love.graphics.print("kills: "..player.kills, width -  4 * 32, height -6 * 20)
  	love.graphics.print("kills to level: "..player.nextlevel, width -  4 * 32, height -5 * 20)
   	love.graphics.print("level: "..player.level, width -  4 * 32, height -4 * 20)
	love.graphics.print("HP: "..player.hp.."/"..player.maxhp, width -  4 * 32, height -3 * 20)
	love.graphics.print("bots on map: "..botn, width -  4 * 32, height -2 * 20)
   	love.graphics.print("bots left: "..botleft, width -  4 * 32, height -1 * 20)
end

function drawscreentimerfunc(victoryorfail)
	drawfunc[2]()
	love.graphics.setColor( 200, 100, 1)
    	love.graphics.rectangle("fill",width/2 -  4 * 32, height/2,8 * 32, 2*32)
	love.graphics.setColor( 0, 0, 0)
	love.graphics.print(victoryorfail, width/2 -  3 * 32, height/2 +10)
	love.graphics.print(screendt, width/2 -  3 * 32, height/2 +42)
end

drawfunc[4] = function() --victory
	drawscreentimerfunc("VICTORY!")
end

drawfunc[-1] = function() --restore
	drawfunc[1]()
end

drawfunc[5] = function() --fail
	drawscreentimerfunc("FAIL!")
end

drawfunc[3] = function() --pause
	drawfunc[2]()
	love.graphics.setColor( 250, 150, 1)
	love.graphics.rectangle("fill", width/2 -  5 * 32 -12, 0, 10*32 + 24,172)
	love.graphics.setColor( 0, 250, 0)
	love.graphics.rectangle("fill",width/2 -  5 * 32,0,10*32,160)
	drawfunc[1]()
end

function love.draw()
	love.graphics.setColor( 0, 250, 0)
	love.graphics.rectangle("fill",0,0,width,height)
	love.graphics.setColor( 255, 255, 255)
	if drawfunc[gamestate] then
		drawfunc[gamestate]()
	end
end

function setmapdrawtext(mapid)
	mapdraw = string.sub(maps[mapid],1,-5)
end
    

function love.keyreleased(key)
    if key == mp1.up and player and player.slip ==0 then
	isup = false
	udt = 0
	pstate = 0
	--souride:stop()
    elseif key == mp1.down and player and player.slip ==0 then
	isdown = false
	ddt = 0
	pstate = 0
	--souride:stop()
    elseif key == mp1.left and player and player.slip ==0 then
	isleft = false
	ldt = 0
	pstate = 0
	--souride:stop()
    elseif key == mp1.right and player and player.slip ==0 then
	isright = false
	rdt = 0
	pstate = 0
	--souride:stop()
    elseif key == mp1.shoot then
	nmenu = false
    end
    if key == "rshift" or key == "lshift" then
	shiftstate = false
    end
    
end

function didbullethit(bullet,bot)
	local bulpoints = {{x=-6,y=-6},{x=6,y=-6},{x=-6,y=6},{x=6,y=6}}
	--local returnval = false
	for i=1,4 do
		if (((bullet.act_y + bullet.draw_y + bulpoints[i].y) > (bot.act_y)) and ((bullet.act_y + bullet.draw_y + bulpoints[i].y) < (bot.act_y +32)) and ((bullet.act_x + bullet.draw_x + bulpoints[i].x) > (bot.act_x )) and ((bullet.act_x + bullet.draw_x + bulpoints[i].x) < (bot.act_x  +32))) then
			return true
			--break
		end
	end
	return false
end

function restorecontroll (bot)
	bot.slipstate = false
	isup = love.keyboard.isDown(mp1.up)
	isdown = love.keyboard.isDown(mp1.down)
	isleft = love.keyboard.isDown(mp1.left)
	isright = love.keyboard.isDown(mp1.right)
	if isup then bot.grid_dir = 0
	elseif isdown then bot.grid_dir = 2
	elseif isleft then bot.grid_dir = 3
	elseif isright then bot.grid_dir = 1 end
end

function testBotMap(bot,x, y) --(edit-30-03-12)
    local id = 0
    local dynamicid = 0
	local id2 = 0
    if map[(bot.grid_y / 32) + y] and map[(bot.grid_y / 32) + y][(bot.grid_x / 32) + x] then 
		id = map[(bot.grid_y / 32) + y][(bot.grid_x / 32) + x]
		dynamicid = dynamicmap[(bot.grid_y / 32) + y][(bot.grid_x / 32) + x]
		if map[(bot.grid_y / 32) + 2*y] and map[(bot.grid_y / 32) + 2*y][(bot.grid_x / 32) + 2*x] then 
			id2 = map[(bot.grid_y / 32) + 2*y][(bot.grid_x / 32) + 2*x]
		end
    else
		return false
    end 
    if hasidslowdowneffect[id] then
		bot.speed = hasidslowdowneffect[id]
    else
		bot.speed = bot.basespeed
    end
    if	hasidsliperyeffect[id] and bot.slip ==0 then
	bot.slip = hasidsliperyeffect[id]
        if bot.atype == "player" then bot.slipstate = true end
    elseif hasidsliperyeffect[id] and bot.slip ~= 0 then
		bot.slip = bot.slip - 1
		if bot.atype == "player" then 
			bot.slipstate = true 
			if bot.slip == 0 then
				restorecontroll (bot)
			end
		end
    else
		bot.slip = 0
		if bot.atype == "player" and bot.slipstate then 
		restorecontroll (bot)
		end
    end
	if hasiddamegeeffect[id] then
		if bot.atype == "player" then
			damageplayer(hasiddamegeeffect[id])
		elseif (bot.hp > hasiddamegeeffect[id]) and (not hasiddamegeeffect[id2]) then
			local rand = math.random(1,2)
			if rand == 1 then 
				damagebot(bot,hasiddamegeeffect[id]) 
			else
				return false
			end
		else
			return false
		end
	end
    if hasidcolision[id] or dynamicid == 1 then
		return false
    elseif bot.atype == "bot"and (dynamicid == 2 or dynamicid == 3)then
		return false
    end
		return true
end
function testbulMap(bot,x, y,tx,ty,lx,ly,rx,ry) --(edit-30-03-12)
    local id = 0
    local dynamicid = {}
    if map[(bot.grid_y / 32)+y] and (map[(bot.grid_y / 32)+y][(bot.grid_x / 32)]+x) then
   	id = (map[(bot.grid_y / 32)+y][(bot.grid_x / 32)+x])
	dynamicid[1] = dynamicmap[(bot.grid_y / 32)+y][(bot.grid_x / 32)+x]
	dynamicid[5] = dynamicmap[(bot.grid_y / 32)][(bot.grid_x / 32)]
	if map[(bot.grid_y / 32)+ty] and (map[(bot.grid_y / 32)+ty][(bot.grid_x / 32)]+tx) then
		dynamicid[2] = dynamicmap[(bot.grid_y / 32)+ty][(bot.grid_x / 32)+tx]
	end
	if map[(bot.grid_y / 32)+ly] and (map[(bot.grid_y / 32)+ly][(bot.grid_x / 32)]+lx) then
		dynamicid[3] = dynamicmap[(bot.grid_y / 32)+ly][(bot.grid_x / 32)+lx]
	end
	if map[(bot.grid_y / 32)+ry] and (map[(bot.grid_y / 32)+ry][(bot.grid_x / 32)]+rx) then
	
		dynamicid[4] = dynamicmap[(bot.grid_y / 32)+ry][(bot.grid_x / 32)+rx]
	end
    else
	return false
    end
    bot.acurat = false
    for i=1,#dynamicid do
	if bot.botid ~= "pla" and isdynamicidplayer[dynamicid[i]] then 
		bot.acurat = true 
		break
	elseif bot.botid == "pla" and isdynamicidbot[dynamicid[i]] then 
		bot.acurat = true 
		break
	end
    end
    if hasidcolisionforbullets[id] then
		if id == 3 then
			map[(bot.grid_y / 32)+y][(bot.grid_x / 32)+x] = 4
		elseif id == 4 then
			map[(bot.grid_y / 32)+y][(bot.grid_x / 32)+x] = 5
		elseif id == 5 then
			map[(bot.grid_y / 32)+y][(bot.grid_x / 32)+x] = 0
		end 
        return false
    end
    return true
end
function isElementOnScreen(x,y)
	return (x > camera._x - 64) and (x < camera._x + width + 64) and (y > camera._y - 64) and (y < camera._y + height + 64)
end

local keyfunc = {}
function love.keypressed(key)
	keyfunc[gamestate](key)
end
keyfunc[1] = function(key) -- menu
	if navtab[key] then navtab[key]()
	elseif curmenu[menustate][key] then curmenu[menustate][key]() end
end

keyfunc[2] = function (key) -- game
	if movetab[key] then movetab[key]() end
end
keyfunc[0] = function (key) -- error
	gamestate = -1
	curmenu = restoretab
end
function postgame(func)
	if not (screentimer > 0) then
		func()
	end
end

function nextmap()
	botleft = dificulitytab[3].botleft + botincreese
	botincreese = botincreese + botincreeseamount
	botn = dificulitytab[2].botn
	mapid = mapid + 1
	if mapid > #maps then mapid =1 end
	setmapdrawtext(mapid)
	suboptions[3].dysplay = "MAP: "..mapdraw
	startgame("next",botleft)
end

function savescore_a()
	local user,ascore
	for u,s in pairs(scoretab[10]) do
		user = u
		ascore = s
	end
	if player.score > ascore then
		gamestate = 7
	else
		startmenu()
	end
end

function savescore()
	scoretab[11] = {[player.name] = player.score}
	local state = true
	local loop = 0
	while state do
  		loop = loop + 1
  		
  		state = false
  		for i,n in pairs(scoretab) do
   			local name,val,name1,val1
    			for j,v in pairs(n) do
      				name = j
      				val = v
    			end
    			if scoretab[i+1] then
    				for j,v in pairs(scoretab[i+1]) do
        				name1 = j
       			 		val1 = v
      				end
      				if val < val1 then 
        				scoretab[i][name]=nil
        				scoretab[i][name1]=val1
        				scoretab[i+1][name1]=nil
        				scoretab[i+1][name]=val
        				--print(name.." = "..val.." < "..name1.." = "..val1)
       					state = true
      
     				 end
    			end
  		end
	end
	scoretab[11] = nil
	local text = "return "..table.tostring(scoretab) 
	love.filesystem.write("score.txt",text)
	gamestate = 6
end

specialkeytab = {
	backspace = function()
		local l = string.len(player.name)
		if l > 0 then
			player.name = string.sub(player.name,0,l-1)
		end
	end,
	lshift = function()
		shiftstate = true
	end,
	rshift = function()
		shiftstate = true
	end,
	["return"] = function()
		local l = string.len(player.name)
		if l > 0 then
			savescore()
		end
	end
}

function typenamefunc(key)
	local l = string.len(player.name)
	if l < 16 then
		if shiftstate then key = string.upper(key) end
		player.name = player.name..key
	end

end

keyfunc[4] = function (key) -- victory
	postgame(nextmap)
end

keyfunc[5] = function (key) -- fail
	postgame(savescore_a)
end

keyfunc[6] = function (key) -- fail
	startmenu()
end

keyfunc[7] = function (key) -- fail
	if specialkeytab[key] then specialkeytab[key]()
	elseif iskeytab[key] then typenamefunc(key) end
end

keyfunc[3] = function (key) -- pause
	keyfunc[1](key)
end

keyfunc[-1] = function (key) -- restore
	keyfunc[1](key)
end

function love.focus(f)
	if not f and gamestate == 2 then
		if playsound then
			souride:stop()
		end
		gamestate = 3
		curmenu = pausemenutab 
		menustate = 2
	end
end
loadconfigfile()